package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.core.ImmutableList
import ru.dbotthepony.mc.otm.block.entity.matter.MatterCapacitorBankBlockEntity
import ru.dbotthepony.mc.otm.core.Decimal
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class MatterCapacitorBankMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: MatterCapacitorBankBlockEntity? = null
) : MatteryMenu(
	MMenus.MATTER_CAPACITOR_BANK, p_38852_, inventory, tile
) {
	val matterGauge: LevelGaugeWidget
	val totalMatterGauge: LevelGaugeWidget

	override val storageSlots: List<MatterContainerInputSlot>

	init {
		if (tile == null) {
			matterGauge = LevelGaugeWidget(this)
			totalMatterGauge = LevelGaugeWidget(this)
		} else {
			matterGauge = LevelGaugeWidget(this, tile)
			totalMatterGauge = LevelGaugeWidget(this, {
				tile.matterGraph?.getMatterStorageLevel() ?: Decimal.ZERO
			}, {
				tile.matterGraph?.getMatterStorageMaxLevel() ?: Decimal.ZERO
			})
		}

		val container = tile?.container ?: SimpleContainer(2 * 6)

		storageSlots = ImmutableList(2 * 6) {
			val slot = MatterContainerInputSlot(container, it)
			addSlot(slot)
			slot
		}

		addInventorySlots()
	}
}
