package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.inventory.Slot
import ru.dbotthepony.mc.otm.block.entity.storage.StoragePowerSupplierBlockEntity
import ru.dbotthepony.mc.otm.registry.MMenus

class StoragePowerSupplierMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: StoragePowerSupplierBlockEntity? = null
) : MatteryPoweredMenu(MMenus.STORAGE_POWER_SUPPLIER, p_38852_, inventory, tile)  {
	var totalTransferred by mSynchronizer.fraction()
	var activeNodes by mSynchronizer.int()

	init {
		addInventorySlots()
	}

	override fun broadcastChanges() {
		if (tile is StoragePowerSupplierBlockEntity) {
			totalTransferred = tile.powerPassed
			activeNodes = tile.cell.storageGraph?.powerDemandingNodes?.size ?: 0
		}

		super.broadcastChanges()
	}

	override val storageSlots: List<Slot> = listOf(batterySlot)
}
