package ru.dbotthepony.mc.otm.menu.widget

import ru.dbotthepony.mc.otm.menu.MatteryMenu

@Suppress("unused")
class ProgressGaugeWidget(menu: MatteryMenu) : AbstractWidget(menu) {
	var progress = {0f}
	var stuck = {false}
	var progressContainer by menu.mSynchronizer.short()
	var stuckContainer by menu.mSynchronizer.bool()

	constructor(
		menu: MatteryMenu,
		progress: () -> Float
	) : this(menu) {
		this.progress = progress
	}

	constructor(
		menu: MatteryMenu,
		progress: () -> Float,
		stuck: () -> Boolean,
	) : this(menu) {
		this.progress = progress
		this.stuck = stuck
	}

	override fun updateServer() {
		progressContainer = (Math.max(Math.min(progress.invoke(), 1f), 0f) * 10_000f).toInt().toShort()
		stuckContainer = stuck.invoke()
	}

	fun isStuck(): Boolean = stuckContainer
	fun percentage(): Float = progressContainer / 10_000f
}
